angular.module('cmb')
.controller('HomeCtrl', function($scope, $http, $alert, $auth, $state, $analytics, myConfig) {
      'use strict';
        $scope.apiurl = myConfig.apiurl+'/api';

        $scope.isAuthenticated = function() {
          return $auth.isAuthenticated();
        };

        $scope.get_groups = function() {
          $http.get($scope.apiurl+'/mygroups', {headers: {'Authorization': 'Bearer '+localStorage.satellizer_token}})
            .success(function(data) {
                $scope.mygroups = data.groups;
            })
            .error(function(error) {
                var message = ( (error && error.message) ? error.message : "Could not connect to server!");
                console.log(error);
                $scope.home_alert = $alert({
                  content: message,
                  container: '.main-content',
                  type: 'error',
                  duration: 5
                });
            });
        };

        $scope.go_to_problem = function(problem_id){
            $state.go('problem', {problem_id: problem_id});
        };

        $scope.go_to_group = function(group_id, group_role){
          if(group_role === "leader"){
            $state.go('leader', {group_id: group_id});
          } else {
            $state.go('group', {group_id: group_id});
          }
        };

        $scope.go_to_public_group = function(group_id){
          $state.go('group', {group_id: group_id});
        };

        $http.get($scope.apiurl+'/problems')
            .success(function(data) {
                $scope.problems = data.problems;
            })
            .error(function(error) {
                var message = ( (error && error.message) ? error.message : "Could not connect to server!");
                console.log(error);
                $scope.home_alert = $alert({
                  content: message,
                  container: '.main-content',
                  type: 'error',
                  duration: 5
                });
            });

        $http.get($scope.apiurl+'/groups/public')
            .success(function(data) {
                $scope.groups = data.groups;
            })
            .error(function(error) {
                var message = ( (error && error.message) ? error.message : "Could not connect to server!");
                console.log(error);
                $scope.home_alert = $alert({
                  content: message,
                  container: '.main-content',
                  type: 'error',
                  duration: 5
                });
            });

        if($auth.isAuthenticated()){
          $scope.get_groups();
        }

        $scope.create_group = function(){
                $state.go('newgroup');
        };
    }
);
