angular.module('cmb')
.controller('LeaderCtrl', function($scope, $http, $alert, $state, $stateParams, $analytics, $window, myConfig) {
      'use strict';
      $scope.apiurl = myConfig.apiurl+'/api';
      $scope.groupUrlParam = '?with-submissions=1';
      $scope.init = false;
      $scope.selectedProblem = "";
      $scope.selectedUser = "";

      $scope.fileUrl = ($window.URL || $window.webkitURL).createObjectURL(new Blob(
                                                [JSON.stringify($scope.group, null, '   ')],
                                                {type: '"application/json"'})
                                              );

      $scope.download_types = [
        {
          "text": "JSON",
          "href": "#blabla",
          "download": "group.json",
          "active": true
        }
      ];

      $scope.initialize = function(){
        $scope.init = true;
        var config = {headers: {'Authorization': 'Bearer '+localStorage.satellizer_token}};
        $http.get($scope.apiurl+'/leader/'+$stateParams.group_id, config)
            .success(function(data) {
              if(data.message === "Leader"){
               $http.get($scope.apiurl+'/problems')
                  .success(function(data){
                    $scope.problems = data.problems;
                  })
                  .error(function(error) {
                    var message = ((error && error.message) ? error.message : "Could not connect to server!");
                    console.log(error);
                    $scope.leader_alert = $alert({
                      content: message,
                      container: '.main-content',
                      placement: 'top',
                      type: 'error',
                      duration: 5
                    });
                });
                $http.get($scope.apiurl+'/users')
                  .success(function(data){
                    $scope.users = data.users;
                  })
                  .error(function(error) {
                    var message = ((error && error.message) ? error.message : "Could not connect to server!");
                    console.log(error);
                    $scope.leader_alert = $alert({
                      content: message,
                      container: '.main-content',
                      placement: 'top',
                      type: 'error',
                      duration: 5
                    });
                });
                var config = {headers: {'Authorization': 'Bearer '+localStorage.satellizer_token}};
                $http.get($scope.apiurl+'/group/'+$stateParams.group_id + $scope.groupUrlParam, config)
                  .success(function(data) {
                    $scope.group = data.group;
                    $scope.fileUrl = ($window.URL || $window.webkitURL).createObjectURL(new Blob(
                                                              [JSON.stringify($scope.group, null, '   ')],
                                                              {type: '"application/json"'})
                                                            );
                  })
                  .error(function(error) {
                    var message = ( (error && error.message) ? error.message : "Could not connect to server!");
                    console.log(error);
                    $scope.leader_alert = $alert({
                      content: message,
                      container: '.main-content',
                      placement: 'top',
                      type: 'error',
                      duration: 5
                    });
                  });
                } else {
                  $state.go('home');
                }
            })
            .error(function(error) {
                var message = ( (error && error.message) ? error.message : "Could not connect to server!");
                console.log(error);
                $scope.leader_alert = $alert({
                  content: message,
                  container: '.main-content',
                  placement: 'top',
                  type: 'error',
                  duration: 5
                });
                $state.go('home');
            });
      };

      $scope.go_to_problem = function(problem_id){
          $state.go('problem', {problem_id: problem_id});
      };

      $scope.go_to_problem_stats = function(problem_id){
          $state.go('leader_prob_stat', {'group_id': $scope.group.id, 'problem_id': problem_id});
      };

      $scope.go_to_user_stats = function(user_id){
          $state.go('leader_user_stat', {'group_id': $scope.group.id, 'user_id': user_id});
      };

      $scope.remove_problem = function(problem_id){
          var config = {headers: {'Authorization': 'Bearer '+localStorage.satellizer_token}};
          $http.delete($scope.apiurl+'/group/'+$scope.group.id+'/problem/'+problem_id, config)
            .success(function(data){
              $scope.group = data.group;
            })
            .error(function(error){
              var message = ((error && error.message) ? error.message : "Could not connect to server!");
                    console.log(error);
                    $scope.leader_alert = $alert({
                      content: message,
                      animation: 'am-fade-and-slide-top',
                      type: 'material',
                      duration: 10
                    });
            });
      };

      $scope.remove_member = function(user_id){
          var config = {headers: {'Authorization': 'Bearer '+localStorage.satellizer_token}};
          $http.delete($scope.apiurl+'/group/'+$scope.group.id+'/member/'+user_id, config)
            .success(function(data){
              $scope.group = data.group;
            })
            .error(function(error){
              var message = ((error && error.message) ? error.message : "Could not connect to server!");
                    console.log(error);
                    $scope.leader_alert = $alert({
                      content: message,
                      animation: 'am-fade-and-slide-top',
                      container: '.main-content',
                      placement: 'top',
                      type: 'error',
                      duration: 5
                    });
            });
      };

      $scope.add_problem = function(){
          if($scope.selectedProblem.id){
            var config = {headers: {'Authorization': 'Bearer '+localStorage.satellizer_token}};
            $http.post($scope.apiurl+'/group/'+$scope.group.id+'/problem/'+$scope.selectedProblem.id, null, config)
              .success(function(data){
                $scope.group = data.group;
                $scope.selectedProblem = "";
              })
              .error(function(error){
                var message = ((error && error.message) ? error.message : "Could not connect to server!");
                      console.log(error);
                      $scope.leader_alert = $alert({
                        content: message,
                        animation: 'am-fade-and-slide-top',
                        container: '.main-content',
                        placement: 'top',
                        type: 'error',
                        duration: 5
                      });
              });
          }
      };

      $scope.add_member = function(){
          if($scope.selectedUser.id){
            var config = {headers: {'Authorization': 'Bearer '+localStorage.satellizer_token}};
            $http.post($scope.apiurl+'/group/'+$scope.group.id+'/member/'+$scope.selectedUser.id, null, config)
              .success(function(data){
                $scope.group = data.group;
                $scope.selectedUser = "";
              })
              .error(function(error){
                var message = ((error && error.message) ? error.message : "Could not connect to server!");
                    console.log(error);
                    $scope.leader_alert = $alert({
                      content: message,
                      animation: 'am-fade-and-slide-top',
                      container: '.main-content',
                      placement: 'top',
                      type: 'error',
                      duration: 5
                    });
            });
          }
      };

      $scope.toggle_public = function(){
        var config = {headers: {'Authorization': 'Bearer '+localStorage.satellizer_token}};
        $http.put($scope.apiurl+'/group/'+$scope.group.id, null, config)
          .success(function(data){
            $scope.group = data.group;
          })
          .error(function(error){
            var message = ((error && error.message) ? error.message : "Could not connect to server!");
                console.log(error);
                $scope.leader_alert = $alert({
                  content: message,
                  animation: 'fadeZoomFadeDown',
                  container: '.main-content',
                  placement: 'top',
                  type: 'error',
                  duration: 5
                });
        });
      };



      $scope.initialize();
});
