angular.module('cmb')
.controller('LeaderUserStatCtrl', function($scope, $http, $alert, $auth, $state, $stateParams, myConfig, _) {
    'use strict';
    $scope._ = _;
    $scope.apiurl = myConfig.apiurl+'/api';
    $scope.orderVar = '+';
    $scope.highscoreOrder = 'time';

    $scope.initialize = function(){
        var config = {headers: {'Authorization': 'Bearer '+localStorage.satellizer_token}};
        $http.get($scope.apiurl+'/leader/'+$stateParams.group_id, config)
            .success(function(data) {
                if(data.message === 'Leader'){
                    $scope.getUser();
                } else {
                    $scope.leader_alert = $alert({
                        content: "Not leader. Redirected to home!",
                        container: '.main-content',
                        placement: 'top',
                        type: 'error',
                        duration: 5
                    });
                    $state.go('home');
                }
            })
            .error(function(error) {
                var message = ( (error && error.message) ? error.message : "Could not connect to server!");
                console.log(error);
                $scope.leader_alert = $alert({
                  content: message,
                  container: '.main-content',
                  placement: 'top',
                  type: 'error',
                  duration: 5
                });
            });
    };

    $scope.getUser = function(){
        $http.get($scope.apiurl+'/user/'+$stateParams.user_id)
            .success(function(data) {
                $scope.user = data.user;
                $scope.getGroup();
            })
            .error(function(error) {
                $scope.get_problem_alert = $alert({
                    content: 'Could not fetch problems from server',
                    container: '.main-content',
                    placement: 'top',
                    type: 'error',
                    duration: 5
                });
                console.log(error);
            });
    };

    $scope.getGroup = function(){
        var config = {headers: {'Authorization': 'Bearer '+localStorage.satellizer_token}};
        $http.get($scope.apiurl+'/group/'+$stateParams.group_id, config)
            .success(function(data) {
                $scope.group = data.group;
                $scope.user.submissions = _.filter($scope.user.submissions, {'visible': true});
                _.forEach($scope.group.problems, function(problem){
                    var tmp = _.filter($scope.user.submissions, {'problem_id': problem.problem_id});
                    if(_.isEmpty(tmp)){
                        problem.submission = {'state': 'Not Delivered'};
                        problem.submission.stateStyle = {'color': 'red'};
                    } else {
                        problem.submission = {'state': 'Submitted'};
                        problem.submission.stateStyle = {'color': 'orange'};
                        _.forEach(tmp, function(sub){
                            if(sub.state === 'finished'){
                                problem.submission = {'state': 'Success'};
                                problem.submission.stateStyle = {'color': 'green'};
                            }
                        });
                    }
                });
            })
            .error(function(error) {
                var message = ( (error && error.message) ? error.message : "Could not connect to server!");
                console.log(error);
                $scope.leader_alert = $alert({
                  content: message,
                  container: '.main-content',
                  placement: 'top',
                  type: 'error',
                  duration: 5
                });
            });
    };

    $scope.go_to_problem_stat = function(problem_id){
        $state.go('leader_prob_stat', {'group_id': $stateParams.group_id, 'problem_id': problem_id});
    };

    $scope.go_to_group = function(){
            $state.go('leader', {group_id: $stateParams.group_id});
        };

    $scope.initialize();

});
