angular.module('cmb')
  .controller('LoginCtrl', function($scope, $alert, $auth, $state) {
    'use strict';

    $scope.$on('$stateChangeSuccess', function (ev, to, toParams, from, fromParams) {
        $scope.lastpage = from.name;
        if($scope.lastpage === 'signup' || $scope.lastpage === 'newpw'){
          $scope.lastpage = 'home';
        }
        $scope.lastpageParams = fromParams;
    });

    $scope.login = function() {
      $auth.login({ name: $scope.name, password: btoa($scope.password) })
        .then(function() {
          $state.go($scope.lastpage, $scope.lastpageParams);
          $alert({
            content: 'You have successfully logged in',
            container: '.main-content',
            placement: 'top',
            type: 'success',
            duration: 3
          });
        })
        .catch(function(response) {
          var message = ( response.data && response.data.message ? response.data.message : "Could not connect to server!");
          $scope.login_alert = $alert({
            content: message,
            container: '.main-content',
            placement: 'top',
            type: 'error',
            duration: 3
          });
        });
    };
  });
