angular.module('cmb')
  .controller('LogoutCtrl', function($scope, $auth, $alert, $state) {
    'use strict';
    if (!$auth.isAuthenticated()) {
      $state.go('home');
    }

    $scope.$on('$stateChangeSuccess', function (ev, to, toParams, from, fromParams) {
        $scope.lastpage = from.name;
        if($scope.lastpage === 'profile' || $scope.lastpage === 'leader'){
          $scope.lastpage = 'home';
        }
        $scope.lastpageParams = fromParams;
    });

    $auth.logout()
      .then(function() {
        $state.go($scope.lastpage, $scope.lastpageParams);
        $scope.logout_alert = $alert({
          content: 'You have been logged out',
          container: '.main-content',
          placement: 'top',
          type: 'info',
          duration: 3
        });
      });
  });
