angular.module('cmb')
.controller('NewGroupCtrl', function($scope, $http, $alert, $auth, $state, $stateParams, $analytics, myConfig) {
      'use strict';
      $scope.apiurl = myConfig.apiurl+'/api';
      $scope.name = null;
      $scope.description = null;
      $scope.members = [];
      $scope.problems = [];

      if(!$auth.isAuthenticated()){
        $state.go('login');
      }

      $scope.create_group = function(){
        if($scope.name === null || $scope.name === ""){
          $scope.create_group_alert = $alert({
              content: 'Name must be filled out.',
              container: '.main-content',
              placement: 'top',
              type: 'info',
              duration: 5
              });
        } else {
          var groupData = {
            name: $scope.name,
            description: $scope.description
          };
          var config = {headers: {'Authorization': 'Bearer '+localStorage.satellizer_token}};
          $http.post($scope.apiurl+'/group/create', groupData, config)
          .success(function(data) {
              $state.go('leader', {group_id: data.group.id});
              })
          .error(function(error) {
              $scope.create_group_alert = $alert({
              content: 'Could not create group.',
              container: '.main-content',
              placement: 'top',
              type: 'error',
              duration: 5
              });
              console.log('Error: ' + error);
          });
        }
      };
    }
);
