angular.module('cmb')
  .controller('ProfileCtrl', function($scope, $http, $auth, $alert, $state, myConfig) {
    'use strict';
    $scope.apiurl = myConfig.apiurl+'/api';
    $scope.newPassword = "";
    $scope.oldPassword = "";
    $scope.password = "";
    $scope.newEmail = "";

    $scope.getProfile = function() {
        var config = {headers: {'Authorization': 'Bearer '+localStorage.satellizer_token}};
        $http.get(myConfig.apiurl+'/api/me', config)
          .success(function(data) {
            $scope.user = data.user;
          })
          .error(function(error) {
            var message = ( error && error.message ? error.message : "Could not connect to server!");
            $scope.get_profile_alert = $alert({
              content: message,
              type: 'error',
              duration: 3
            });
          });
    };

    $scope.updatePassword = function() {
      if($scope.confirmNewPassword === $scope.newPassword){
        $scope.updating_password_alert = $alert({
          content: 'Updating Password',
          container: '.main-content',
          placement: 'top',
          type: 'info',
          duration: 3
        });
        var profileData = {
          type: 'password',
          password: btoa($scope.oldPassword),
          new_password: btoa($scope.newPassword)
        };
        $scope.newPassword = "";
        $scope.oldPassword = "";
        $scope.confirmNewPassword = "";
        $scope.myForm.$setPristine();
        var config = {headers: {'Authorization': 'Bearer '+localStorage.satellizer_token}};
        $http.put($scope.apiurl+'/me', profileData, config)
          .success(function(data){
            $scope.user = data.user;
            $scope.updated_password_alert = $alert({
              content: 'Password Updated',
              container: '.main-content',
              placement: 'top',
              type: 'success',
              duration: 5
            });
          })
          .error(function(error) {
            $scope.myForm.oldPassword.$dirty = true;
            var message = ( error && error.message ? error.message : "Could not connect to server!");
            $scope.update_password_alert = $alert({
              content: message,
              container: '.main-content',
              placement: 'top',
              type: 'error',
              duration: 5
            });
          });
      } else {
          $scope.newPassword = "";
          $scope.oldPassword = "";
          $scope.confirmNewPassword = "";
          $scope.update_password_alert = $alert({
              content: 'New Passwords did not match!',
              container: '.main-content',
              placement: 'top',
              type: 'error',
              duration: 3
            });
      }
    };

    $scope.updateEmail = function() {
      if($scope.newEmail === $scope.confirmEmail){
        var profileData = {
          type: 'email',
          password: btoa($scope.password),
          email: $scope.newEmail
        };
        $scope.newEmail = "";
        $scope.password = "";
        $scope.confirmEmail = "";
        $scope.emailForm.$setPristine();
        var config = {headers: {'Authorization': 'Bearer '+localStorage.satellizer_token}};
        $http.put(myConfig.apiurl+'/api/me', profileData, config)
          .success(function(data){
            $scope.user = data.user;
            $scope.update_email_alert = $alert({
              content: 'Email Updated',
              container: '.main-content',
              placement: 'top',
              type: 'success',
              duration: 5
            });
          })
          .error(function(error) {
            if(error.message==="User with email already exist!"){
              $scope.emailForm.newEmail.$dirty = true;
            } else {
              $scope.emailForm.password.$dirty = true;
            }
            var message = ( error && error.message ? error.message : "Could not connect to server!");
            $scope.update_email_alert = $alert({
              content: message,
              container: '.main-content',
              placement: 'top',
              type: 'error',
              duration: 3
            });
          });
      } else {
          $scope.newEmail = "";
          $scope.password = "";
          $scope.confirmEmail = "";
          $scope.emailForm.newEmail.$dirty = true;
          $scope.emailForm.confirmEmail.$dirty = true;
          $scope.update_email_alert = $alert({
              content: 'Emails did not match.',
              container: '.main-content',
              placement: 'top',
              type: 'error',
              duration: 3
            });
      }
    };

    $scope.getProfile();

  });
