angular.module('cmb')
  .controller('ProfilingCtrl', function($scope, $sce, $http, $alert, $auth, $modal, $state,
                                      $stateParams, socketio, myConfig, _) {
    'use strict';

    $scope._ = _;
    $scope.apiurl = myConfig.apiurl+'/api';

    $scope.sub_id = $stateParams.submission_id;

    $http.get($scope.apiurl+'/flamegraph/'+$stateParams.submission_id)
      .success(function(data) {
          $scope.error_msg = '';
      })
      .error(function(error) {
          $scope.get_problem_alert = $alert({
              content: 'No flame graph for current submission.',
              container: '.main-content',
              placement: 'top',
              type: 'warning',
              duration: 5
          });
          $scope.error_msg = "Unavailable";
    });

    $http.get($scope.apiurl+'/submission/'+$stateParams.submission_id)
      .success(function(data) {
          console.log(data);
          $scope.profiling_data = $.parseJSON(data.submission.profiling_data);
      })
      .error(function(error) {
          $scope.get_problem_alert = $alert({
              content: 'Could not fetch profiling data from server',
              container: '.main-content',
              placement: 'top',
              type: 'error',
              duration: 5
              });
          console.log(error);
    });

    $scope.getNameValue = function(key, value) {
      if (key == 'LLC-load-misses') {
        var name = 'Last level cache misses';
        var percentage = (100 * Number(value) / Number($scope.profiling_data['LLC-loads'])).toFixed(2);
        var val = Number(value).toLocaleString('en') + " (" + percentage + " %)";
      }
      else if (key == 'LLC-loads') {
        var name = 'Last level cache loads';
        var val = Number(value).toLocaleString('en');
      }
      else if (key == 'L1-dcache-load-misses') {
        var name = 'First level cache misses';
        var percentage = (100 * Number(value) / Number($scope.profiling_data['L1-dcache-loads'])).toFixed(2);
        var val = Number(value).toLocaleString('en') + " (" + percentage + " %)";
      }
      else if (key == 'L1-dcache-loads') {
        var name = 'First level cache loads';
        var val = Number(value).toLocaleString('en');
      }
      else if (key == 'instructions') {
        var name = 'Instructions';
        var ipc = (Number(value) / Number($scope.profiling_data['cycles'])).toFixed(2);
        var val = Number(value).toLocaleString('en') + " (" + ipc + " IPC)";
      }
      else if (key == 'cycles') {
        var name = 'Cycles';
        var val = Number(value).toLocaleString('en');
      }
      else {
        var name = key;
        var val = value;
      }
      return [name, val];
    };

    $scope.getName = function(key, value) {
      return $scope.getNameValue(key, value)[0];
    }

    $scope.getValue = function(key, value) {
      return $scope.getNameValue(key, value)[1];
    }

    $scope.isNull = function(value) {
      return (value == null);
    };

    $scope.isAuthenticated = function() {
        return $auth.isAuthenticated();
    };
  });
