angular.module('cmb')
  .controller('SignupCtrl', function($scope, $alert, $auth, $state) {
    'use strict';
    $scope.$on('$stateChangeSuccess', function (ev, to, toParams, from, fromParams) {
        $scope.lastpage = from.name;
        $scope.lastpageParams = fromParams;
    });

    $scope.signup = function() {
      if($scope.confirm_password === $scope.password){
        if($scope.confirm_email === $scope.email){
          $auth.signup({
          email: $scope.email,
          name: $scope.name,
          password: btoa($scope.password)
          }).then(function(response) {
              $state.go($scope.lastpage, $scope.lastpageParams);
              $scope.signup_alert = $alert({
                content: 'You have successfully signed up',
                container: '.main-content',
                placement: 'top',
                type: 'success',
                duration: 3
              });
            })
            .catch(function(error) {
              var message = ( error.data && error.data.message ? error.data.message : "Could not connect to server!");
              $scope.signup_alert = $alert({
                content: message,
                container: '.main-content',
                placement: 'top',
                type: 'error',
                duration: 5
              });
            });
        } else {
          $scope.email = "";
          $scope.confirm_email = "";
          $scope.signup_alert = $alert({
              content: "Emails did not match!",
              container: '.main-content',
              placement: 'top',
              type: 'error',
              duration: 3
            });
        }
      } else {
        $scope.password = "";
        $scope.confirm_password = "";
        $scope.signup_alert = $alert({
              content: "Passwords did not match!",
              container: '.main-content',
              placement: 'top',
              type: 'error',
              duration: 3
            });
      }

    };
  });
