var cmb = angular.module('cmb',
                  ['ngResource',
                   'ngAnimate',
                   'ngMessages',
                   'ui.router',
                   'mgcrea.ngStrap',
                   'ngSanitize',
                   'btford.socket-io',
                   'angularSpinner',
                   'satellizer',
                   'cmb.config',
                   'angulartics',
                   'angulartics.google.analytics'])
  .config(function($stateProvider, $urlRouterProvider, $authProvider,  $compileProvider, $modalProvider, socketFactoryProvider, myConfig) {
    $stateProvider
      .state('home', {
        url: '/',
        templateUrl: 'partials/home.html',
        controller: 'HomeCtrl',
        resolve: {
          init: function(bulletins) {
            bulletins.show();
          }
        }
      })
      .state('login', {
        url: '/login',
        templateUrl: 'partials/login.html',
        controller: 'LoginCtrl'
      })
      .state('signup', {
        url: '/signup',
        templateUrl: 'partials/signup.html',
        controller: 'SignupCtrl'
      })
      .state('logout', {
        url: '/logout',
        template: null,
        controller: 'LogoutCtrl'
      })
      .state('profile', {
        url: '/profile',
        templateUrl: 'partials/profile.html',
        controller: 'ProfileCtrl',
        resolve: {
          authenticated: ['$location', '$auth', function($location, $auth) {
            if (!$auth.isAuthenticated()) {
              return $location.path('/login');
            }
          }]
        }
      })
      .state('problem', {
        url: '/problem/:problem_id',
        templateUrl: 'partials/problem.html',
        controller: 'ProblemCtrl'
      })
      .state('profiling', {
        url: '/profiling/:submission_id',
        templateUrl: 'partials/profiling.html',
        controller: 'ProfilingCtrl'
      })
      .state('newgroup', {
        url: '/group/new',
        templateUrl: 'partials/newgroup.html',
        controller: 'NewGroupCtrl'
      })
      .state('group', {
        url: '/group/:group_id',
        templateUrl: 'partials/group.html',
        controller: 'GroupCtrl'
      })
      .state('leader_prob_stat', {
        url: '/leader/:group_id/problem/:problem_id',
        templateUrl: 'partials/leader_problem_stats.html',
        controller: 'LeaderProbStatCtrl'
      })
      .state('leader_user_stat', {
        url: '/leader/:group_id/member/:user_id',
        templateUrl: 'partials/leader_user_stats.html',
        controller: 'LeaderUserStatCtrl'
      })
      .state('leader', {
        url: '/leader/:group_id',
        templateUrl: 'partials/leader.html',
        controller: 'LeaderCtrl'
      })
      .state('error', {
        url: '/error/:sub_id',
        templateUrl: 'partials/error_msg.html',
        controller: 'ErrorMsgCtrl'
      })
      .state('newpw', {
        url: '/forgot_password',
        templateUrl: 'partials/forgot_password.html',
        controller: 'ForgotPwCtrl'
      })
      .state('howto', {
        url: '/howto',
        templateUrl: 'partials/howto.html'
      });

    $urlRouterProvider.otherwise('/');
    $authProvider.loginUrl = myConfig.apiurl+'/auth/login';
    $authProvider.signupUrl = myConfig.apiurl+'/auth/signup';

    angular.extend($modalProvider.defaults, {
        html: true
    });

    $compileProvider.aHrefSanitizationWhitelist(/^\s*(|blob|):/);
  });
