cmb.factory('bulletins', function($http, $alert, _, myConfig) {
  var bulletins = [];
  this.init = false;

  function fetchBulletins() {
     return $http.get(myConfig.apiurl+'/api/bulletins/active');
  }

  function getContentString(bulletin) {
    return bulletin.content + '<br><p class=bulletin-date>Valid until: ' + bulletin.valid_until.slice(0,26) + '</p>';
  }

  function removeBulletins(list) {
    _.map(list, function(bulletin) {
      $('div').remove('.bulletin-'+bulletin.id);
      _.remove(bulletins, function(elem) {
        return bulletin.id == elem.id;}
      );
    });
  }

  return {
   show: function() {
     if(!this.init){
       fetchBulletins()
         .success(function(data) {
           var loadedData = data.bulletins;
           var toShow = _.differenceWith(loadedData, bulletins, _.isEqual);
           var toRemove = _.differenceWith(bulletins, loadedData, _.isEqual);
           removeBulletins(toRemove);
           for(var i = 0; i < toShow.length; i++) {
             bulletin = toShow[i];
             bulletins.push(bulletin);
             $alert({
               content: getContentString(bulletin),
               container: '.bulletin-board',
               type: 'bulletin bulletin-' + bulletin.id,
               dismissable: bulletin.removable
             });
           }
           this.init = true;
         })
         .error(function(error) {
           console.log(error);
         });
     }
   },
  };
});
