describe('Unit ForgotPwCtrl: ', function() {
  // Load the module with Controller
  beforeEach(module('cmb'));

  var ctrl, scope;

  beforeEach(inject(function($controller, $rootScope) {
    // Create a new scope that's a child of the $rootScope
    scope = $rootScope.$new();
    // Create the controller
    ctrl = $controller('ForgotPwCtrl', {
      $scope: scope
    });
  }));

  describe('requestNewPassword http post request: ', function() {
    beforeEach(inject(function($httpBackend) {      
      httpBackend = $httpBackend;
      httpBackend.whenGET(/^.*$/).respond(500, '');
    }));

    afterEach(function() {
      httpBackend.verifyNoOutstandingExpectation();
      httpBackend.verifyNoOutstandingRequest();
    });

    it('success', inject(function($state){
      spyOn($state, 'go').and.callFake(function(state){});
      scope.name = 'test';
      scope.email = 'test@email.com';
      var profileData = {'username': 'test', 'email': 'test@email.com'};
      var response = {'email': 'test@email.com'};
      httpBackend.expectPOST(scope.apiurl+'/forgot_password', profileData, function(headers){
        return !_.isUndefined(headers.Authorization);
      }).respond(200, response);
      scope.requestNewPassword();         
      httpBackend.flush();
      expect(scope.req_pw_alert.$options.content).toEqual('New Password Sent to test@email.com');
      expect($state.go).toHaveBeenCalledWith('login');
    }));

    it('failure', function(){
      httpBackend.expectPOST(scope.apiurl+'/forgot_password').respond(500);
      scope.requestNewPassword();         
      httpBackend.flush();
      expect(scope.req_pw_alert.$options.content).toEqual('Request for new password failed. Please contact admin.');
    });
  });
});
