describe("Directive:", function () {
 
    beforeEach(module('cmb'));
 
    describe("template", function () {
         var $compile;
         var $scope;
         var httpBackend;
 
         // Load the templates module
         beforeEach(module('templates'));
 
         // Angular strips the underscores when injecting
         beforeEach(inject(function(_$compile_, _$rootScope_, $httpBackend) {
             $compile = _$compile_;
             $scope = _$rootScope_.$new();
             httpBackend = $httpBackend;
      		 httpBackend.whenGET(/^.*$/).respond(500, '');
        }));

    	afterEach(function() {
    		httpBackend.flush();
    	  	httpBackend.verifyNoOutstandingExpectation();
    	  	httpBackend.verifyNoOutstandingRequest();
    	});

        it("should call updatePassword when Enter is pressed",
        	inject(function($) {
            	$scope.updatePassword = function(){};
            	spyOn($scope, 'updatePassword').and.callFake(function() {});
            	var e = $.Event("keydown", {
   					keyCode: 13
				});	
            	var elm = angular.element('<div ng-enter="updatePassword()"></div>');
            	var template = $compile(elm)($scope);
            	template.trigger(e);
            	$scope.$digest();
            	expect($scope.updatePassword).toHaveBeenCalled();
            }));

        it("should not call updatePassword when other keys are pressed",
        	inject(function($) {
            	$scope.updatePassword = function(){};
            	spyOn($scope, 'updatePassword').and.callFake(function() {});
            	var e = $.Event("keydown", {
   					keyCode: 15
				});	
            	var elm = angular.element('<div ng-enter="updatePassword()"></div>');
            	var template = $compile(elm)($scope);
            	template.trigger(e);
            	$scope.$digest();
            	expect($scope.updatePassword).not.toHaveBeenCalled();
            }));
    });
});