from scipy import integrate
import sys
import os.path

array = []

if len(sys.argv) < 5:
    print("Wrong number of arguments!")
    sys.exit()

energy_readings_file = str(sys.argv[1])
delta_x = float(sys.argv[2])
start_time = int(sys.argv[3])
end_time = int(sys.argv[4])
DEBUG = 'True' == sys.argv[5]

if DEBUG:
    print(energy_readings_file, delta_x, start_time, end_time)

json = '{'

if not os.path.isfile(energy_readings_file):
    print(0)
    sys.exit(0)

skipped_lines_count = 0
with open(energy_readings_file, 'r') as ins:
    for line in ins:
        temp=line.rstrip().split(',')

        if len(temp) != 13 or start_time > int(temp[0]) or int(temp[0]) > end_time:
            skipped_lines_count += 1
            continue

        startIndex = 3
        step = 3
        array.append(float(temp[startIndex]) + float(temp[startIndex + step]) +
                        float(temp[startIndex + 2*step]) + float(temp[startIndex + 3*step]))

energy = integrate.simps(array, dx=delta_x)

json += '"energy":' + str(energy)

if DEBUG:
    print("Skipped:", skipped_lines_count)

print(json)
