import sys
import os.path
import operator
import re

def remove_arguments(fun_string):
    fun_string = re.sub(r'\([^)]*', '()', fun_string)
    return re.sub(r'\(\)\)', '()', fun_string)


def get_fun_name(words):
    tmp = ''
    if words[2] == 'in':
        start = 3
    else:
        start = 1
    for i in range(start, 1000):
        try:
            if words[i] in ['at', 'from']:
                break
        except IndexError:
            break
        tmp += words[i]
    tmp = remove_arguments(tmp)
    if words[0] != '#0':
        tmp += ';'
    return tmp

def insert_stack(stack, dic):
    if stack in dic:
        dic[stack] += 1
    elif stack != '' and stack != ';':
        dic[stack] = 1



array = []
if len(sys.argv) < 2:
    print("Wrong number of arguments!")
    sys.exit()

qs_stacks_file = str(sys.argv[1])

distinguish_threads = True
if len(sys.argv) > 2:
    distinguish_threads = False

if not os.path.isfile(qs_stacks_file):
    sys.exit(0)

folded_stacks = {}
stack = ''
thread = ''
with open(qs_stacks_file, 'r') as ins:
    for line in ins:
        if line[:6] == 'Thread':
            # Insert previous into dict
            if distinguish_threads:
                stack = thread + ';' + stack
            insert_stack(stack, folded_stacks)

            # Init next one
            thread = line[:8]
            stack = ''
        elif line[0] == '#':
            words = line.split()
            stack = get_fun_name(words) + stack


sorted_stacks = sorted(folded_stacks.items(), key=operator.itemgetter(0))                
for key, value in sorted_stacks:
    print key, value
