#!/bin/bash
#FRONTEND_DIR and FLASK_DIR is defined in server.cfg
. $APPLICATION_SETTINGS
logfile="/srv/climber/cmb/server/cmb-flask/logs/startup.log"
set -e
function start_cmb {
	cd $FRONTEND_DIR && gulp maintenance 2>&1 >> $logfile

	echo "starting server..."
	sleep 1

	{ $FLASK_DIR/scripts/gunicorn_start 2>&1 >> $logfile &} > /dev/null
	disown
	sleep 3

	echo "starting frontend..."
	cd $FRONTEND_DIR && gulp $VERSION 2>&1 >> $logfile
	echo "CMB started"
}

function stop_cmb {
	set +e
	pkill gunicorn
	set -e
	sleep 1
	echo "CMB stopped"
}

case "$1" in

start) stop_cmb
       sleep 1
       start_cmb
;;
stop) stop_cmb
;;
restart) stop_cmb
	sleep 1
	start_cmb
;;
*) echo "Please pass 'start', 'restart' or 'stop' as argument"
esac
