import os
import subprocess32

from cmb_utils.helpers import execute_command


class CheckerError(Exception):
    pass


class Checker:
    @staticmethod
    def run(problem_io_dir):
        input_path = os.path.join(problem_io_dir, 'input.txt')
        solution_path = os.path.join(problem_io_dir, 'solution.txt')
        answer_path = os.path.join(problem_io_dir, 'answer.txt')
        checker_path = os.path.join(problem_io_dir, 'checker')
        try:
            output = execute_command([checker_path, input_path, solution_path, answer_path])
        except subprocess32.CalledProcessError as e:
            print e
            raise CheckerError()

        # All checkers return exit status != 0 with the wrong solution, so the above exception is thrown.

        lines = output.splitlines()
        correct = True
        goodness = None
        if len(lines) > 1:
            goodness = lines[1]

        return correct, goodness


# if __name__ == '__main__':
#     print(Checker.run(r'/home/fred/dev/cmb/server/cmb-flask/problems/vertex_cover/problemIO'))
