from flask import Blueprint
from flask.ext.socketio import emit, join_room, leave_room
from server import socketio

problem_events = Blueprint('problem_events', __name__, None)


@socketio.on('join-problem', namespace='/cmb')
def join_problem_room(message):
    room = message['prob_id']
    join_room(room)
    emit('message', {'msg': 'Client entered room of problem id ' + room}, room=room)


@socketio.on('leave-problem', namespace='/cmb')
def leave_problem_room(message):
    room = message['prob_id']
    leave_room(room)
    emit('message', {'msg': 'Client left room of problem id ' + room}, room=room)
