from flask import Blueprint, jsonify

from datetime import datetime
from database.models import Bulletin
from cmb_utils.helpers import bulletin_to_json


bulletin_routes = Blueprint('bulletin_routes', __name__, None)


def get_current_time():
    return datetime.now()


@bulletin_routes.route('/api/bulletins/active', methods=['GET'])
def get_active_bulletins():
    active_bulletins = Bulletin.query.filter(Bulletin.valid_until > get_current_time()).all()
    if not active_bulletins:
        response = jsonify(message='No active bulletins.')
        response.status_code = 404
        return response
    return jsonify({'bulletins': map(bulletin_to_json, active_bulletins)})


@bulletin_routes.route('/api/bulletins', methods=['GET'])
def get_bulletins():
    bulletins = Bulletin.query.all()
    if not bulletins:
        response = jsonify(message='No bulletins.')
        response.status_code = 404
        return response
    return jsonify({'bulletins': map(bulletin_to_json, bulletins)})
