# import urllib2

import requests
from flask import Flask
from flask.ext.testing import LiveServerTestCase, TestCase
from sqlalchemy.exc import OperationalError

from database.models import Problem
from server import create_app, db, delete_db, init_db


class MyTest(LiveServerTestCase):
    def create_app(self):
        app = Flask(__name__)
        app.config['TESTING'] = True
        app.config['LIVESERVER_PORT'] = 8943
        return app

    def test_server_is_up_and_running(self):
        print self.get_server_url()
        response = requests.get("http://127.0.0.1:8943")
        self.assertEquals(response.status_code, 404)


class serverTest(TestCase):
    Testing = True

    def create_app(self):
        tmp = create_app(self, push=False)
        # tmp.config['SERVER_PORT']=1337
        tmp.config['Testing'] = True
        tmp.config['SQLALCHEMY_DATABASE_URI'] = "sqlite:///tests/testDB"
        return tmp

    def test_init_and_delete_db(self):
        self.app.config['SQLALCHEMY_DATABASE_URI'] = "sqlite:///tests/testDBmethods"
        init_db()
        problem = Problem("Test", "test")
        db.session.add(problem)
        db.session.commit()
        test_problem = Problem.query.filter_by(id=1).first()
        self.assertEquals(test_problem.name, "Test")
        db.session.remove()
        delete_db()
        try:
            test_problem2 = Problem.query.filter_by(id=1).first()
        except OperationalError:
            test_problem2 = "error"
        self.assertEquals(test_problem2, "error")
